CON

_clkmode = xtal1 + pll16x
_xinfreq = 5_000_000
_stack   = 200

  SCANLINE_BUFFER = gfx#SCANLINE_BUFFER
  NUM_LINES = gfx#NUM_LINES
                                               
 border_color                   = gfx#border_color ' border color
 displaylist_adr                = gfx#displaylist_adr 'pointer to display list
 displaylist_in_use             = gfx#displaylist_in_use 'display list adress feedback

 END_OF_DRIVER_RESERVED = gfx#MEMORY_END

 DLIST_SIZE = 1600 ' longs

 _free    = ($8000-END_OF_DRIVER_RESERVED+3)/4   

OBJ

gfx : "VJET_v01_composite_wrapper_xasm.spin" 
pst: "DummyPST"'}"Parallax Serial Terminal"
gl  : "VJET_v01_displaylist.spin"
fsrw: "fsrw_readonly.spin"
plat: "platform.spin"

VAR

long framecount,presenttime

word dlist1ptr,dlist2ptr

long vert_in_buffer[16/2],vert_out_buffer[16*2] 

word indexedverts[256]

byte overflow_flag,frame_flags,done_flag

DAT

palette word
word $0202
word $0203
word $0303
word $0304
word $0404
word $0405
word $0505
word $0506
word $0606
word $0607
word $0707
word $0D0D
word $4D4D
word $6D6D
word $8D8D
word $CDCD

palconv word
file "palconv.raw" '' BRG333 to VJET colors

org
dlist_space '' Display list space
render_asm file "VJET_v01_rendering.dat"
tv_asm file "VJET_v01_composite.dat"
long $00[DLIST_SIZE*2-$]

PUB main
init
repeat
  done_flag:=0
  start
  
  {repeat 2
    do_frame
   
  'repeat}
     
  repeat until done_flag
    do_frame
  repeat 100
    gfx.Wait_Vsync
      

PRI init | err

pst.start(115_200)

'pst.str(string("mounting... "))
err := \fsrw.mount_explicit(plat#spiDO,plat#spiCLK,plat#spiDI,plat#spiCS)
repeat while err
  'pst.str(string(13,"FSRW MOUNT ERROR "))
  'pst.dec(err)
'pst.str(string(" opening P8XNICCC.SCN... ")) 
'pst.newline

word[displaylist_adr] := $8080
''set up graphics driver
gfx.start(plat#TV_PINGROUP,4,@render_asm,@tv_asm) 'start graphics driver

dlist1ptr := @dlist_space
dlist2ptr := @dlist_space+constant(DLIST_SIZE*4)
longfill(@dlist_space,0,constant(DLIST_SIZE*2)) ' this is neccessary to make sure the graphics cogs don't go off the deep end

'pst.str(string(13,"Init done...",13))

PRI start | err
err := \fsrw.popen(string("P8XNICCC.SCN"),"r")
repeat while err
  'pst.str(string(13,"FSRW OPEN ERROR "))
  'pst.dec(err)
gl.set_clip(0,gfx#HEIGHT<<16,0,gfx#WIDTH<<16)

PRI do_frame | tmp

  repeat
    tmp:= presenttime - cnt
    if tmp < 0
      quit
    if tmp > (clkfreq>>3)
      quit  
  gfx.Wait_Vsync         
  {if overflow_flag~
    tmp:=$CC
  else
    tmp:=$2D}
  word[border_color]:=$02'tmp
  ifnot framecount&1
    word[displaylist_adr] := dlist1ptr
    gl.start(dlist2ptr,constant(DLIST_SIZE*4)) 
  else
    word[displaylist_adr] := dlist2ptr
    gl.start(dlist1ptr,constant(DLIST_SIZE*4))
  framecount++

  presenttime := cnt + (clkfreq>>5) ' cap at 32 FPS (in effect, 30 FPS cap)

  'pst.str(string("frame "))
  'pst.dec(framecount)
  'pst.newline                            

  if tmp := \draw
    'pst.str(string("ABORT "))
    'pst.dec(tmp)
    pst.newline
   
  if tmp:=gl.done    
    'pst.str(string("DLIST OVRFLOW: "))
    'pst.dec(tmp)
    'pst.newline
   
  
  'pst.str(string("onek "))
  'pst.hex(framecount,8)
  'pst.newline
  'word[border_color]:=$04
  'word[@testdlist][1] := 50+(sin(framecount*63)/2048)
  'word[@testdlist][2] := word[@testdlist][1]+20

PRI draw | tmp,tmp2,descriptor,vcount,vertex,indexed_flag

'gl.triangle($10_0000,$10_0000,$20_0000,$C_0000,$8_0000,$30_0000,$0706)
'gl.box(16,16,32,32,$0504)
'{
frame_flags:=fsrw.pgetc

if frame_flags & %0010 ' frame has new palette?
  'pst.str(string("New palette...",13))
  tmp:= getword_be><16 ' read bit mask of updated colors 
  tmp2:=@palette'+constant(15*2)
  repeat 16
    if tmp&1
      vertex := getword_be
      word[tmp2] := palconv.word[(vertex&%111)|((vertex>>5)&%111000)|((vertex<<2)&%111000000)]      
    tmp>>=1
    tmp2+=2

if indexed_flag:=(frame_flags & %0100) ' frame is indexed mode?
  'pst.str(string("indexed mode, "))
  tmp:=fsrw.pgetc ' read vertex count
  'pst.dec(tmp)
  'pst.str(string(" vertices.",13))
  fsrw.pread(@indexedverts,tmp<<1) ' read vertices

' main thing
repeat
  descriptor:=fsrw.pgetc ' read descriptor (top nibble = color, bottom nibble = vcount)
  case descriptor
    $FD:
      done_flag~~
      return
    $FE:                             
      tmp:=(fsrw.tell+$FFFF)&$FF_0000
      repeat until fsrw.tell == tmp
        fsrw.pread(@indexedverts,(tmp-fsrw.tell)<#512)
      return
    $FF:
      return
    other:
      vcount:=descriptor&$F
      if indexed_flag
        fsrw.pread(@vert_in_buffer,vcount)
      else
        fsrw.pread(@vert_in_buffer,vcount<<1) 
      tmp := @vert_in_buffer
      tmp2:= @vert_out_buffer
      repeat vcount
        if indexed_flag
          vertex := indexedverts[byte[tmp++]]
        else
          vertex := word[tmp]
          tmp+=2                             
        long[tmp2] := (vertex << 16)&$FF0000
        tmp2+=4
        long[tmp2] := (vertex <<  8)&$FF0000 + constant(20<<16)
        tmp2+=4
      ifnot overflow_flag
        overflow_flag := 0 > \gl.polygon(@vert_out_buffer,vcount,palette[descriptor>>4],-1)
'}        
       
          
                      
PRI getword_le ' get little endian word
 return fsrw.pgetc + (fsrw.pgetc << 8)

PRI getword_be ' get big endian word
 return (fsrw.pgetc << 8) + fsrw.pgetc
